enum md23_regs { SPEED1=0,    // R/W, Motor1 speed 
		           SPEED2, // R/W, Motor2 speed (mode 0,1) or turn (mode 2/3)
					  ENC1A,       // R,   Enc 1 high-byte
					  ENC1B,       // R,   Enc 1 2nd byte
					  ENC1C,       // R,   Enc 1 3rd byte
					  ENC1D,       // R,   Enc 1 low byte
					  ENC2A,       // R,   Enc 2 high-byte
					  ENC2B,       // R,   Enc 2 2nd byte
					  ENC2C,       // R,   Enc 2 3rd byte
					  ENC2D,       // R,   Enc 2 low byte
					  BATT,        // R,   Battery (Volts*10)
					               //    fixed pt delta=0.1 (121==12.1V)
					  M1CURRENT,   // R,   Motor1 Current (Amps*10)
					               //    fixed pt delta=0.1 (25=2.5A)
					  M2CURRENT,   // R,   Motor2 Current (Apps*10)
					               //    fixed pt delta=0.1 (25=2.5A)
					  MD23_REVISION,    // R,   Software Revision Number
					  ACCEL,       // R/W, Acceleration Rate (default=5)
										// size of power steps when accelerating
										// e.g. if motors travelling at full fwd
										// (255), changed to full reverse (0), there
										// would be 255 steps with ACCEL REG=1, but only
										// 128 for ACCEL REG=2.
										//
					               // e.g. default=5, maps to full fwd to full rev
										//  (51 steps) in 1.25s, or 25ms/step
					  MODE,        // R,W, Mode of Operation
//   Mode 0 (default) - unsigned speed
//     SPEED1=Motor1 (0=0x00=full rev, 128=0x80=stop, 255=0xFF=full fwd)
//     SPEED2=Motor2 
//   Mode 1 - signed speed
//     SPEED1=Motor1 (-128=0xFF=full rev, 0x00=0=stop 127=0x7F=full fwd)
//     SPEED2=Motor2 
//   Mode 2 - unsigned speed/turn
//     Motor1 = speed+turn
//     Motor2 = speed-turn
//   Mode 3 - signed speed/turn
//     Motor1 = speed+turn
//     Motor2 = speed-turn
					  MD23_COMMAND};    // R/W, Used to reset encoder counts and
                              //       change address of modules

enum md32_cmds { CLEAR_ENCS=0x20, // clear encoder counts
		           DISABLE_ASR=0x30, // disable automatic speed regulation
					  ENAGLE_ASR,       // enable ASR (default)
					  DISABLE_TIMEOUT,  // disable 2s timeout 
					  ENABLE_TIMEOUT,  //  enable TO when no I2C comms (default)
						CHANGE_I2C_ADDR_1=0xA0, // change I2C address
						CHANGE_I2C_ADDR_2=0xAA,
						CHANGE_I2C_ADDR_3=0xA5};
