#include <stdio.h>
#include <stdlib.h>
#include <termios.h>
#include <unistd.h>  // usleep 
#include <fcntl.h>   // file serial stuff 
#include <sys/ioctl.h>
#include "usb_i2c.h"
#include "md23.h"

// This reads and prints out the battery voltage.  For some strange reason,
// if I request a read from reg 10, the USB-I2C will read from 11, so I
// read 2 bytes from reg 9 instead.  Hack!
// KMN 7/16/2007

BYTE ReadBatt(BYTE addr) {
	BYTE *sbuf;
	BYTE voltage;

#if 0
	// Verify the address by reading the rev
	printf("Checking address 0x%02X for MD23 ...",addr);
	sbuf = Read_i2c(addr,MD23_REVISION,1);
	if(sbuf[0]>0 && sbuf[0]<20) { // found one!
			printf("found one, revision %i!\n",sbuf[0]);
	}
	free(sbuf);

 	printf("Sending reset...");
	Write_i2c(addr,MD23_COMMAND,CLEAR_ENCS);

#endif
	printf("Reading Batt Voltage of MD23 @ %02x .. ",addr);
	sbuf = Read_i2c(addr,9,2);
	voltage = sbuf[1];
	free(sbuf);

	return voltage;
}


int main (int argc, char *argv[]) {
 BYTE addr=0xb4;
 BYTE batt=0;

 if (SerialOpen("/dev/ttyUSB0",B19200)<0)
	if (SerialOpen("/dev/ttyUSB1",B19200)<0) {
			fprintf(stderr,"Problem opening port");
			return -1;
 }

 batt = ReadBatt(addr);
 printf("Batt Voltage is %i (%i.%i v)\n",batt,batt/10,batt%10);
 return 0;
} 
