#include <stdio.h>
#include <stdlib.h>
#include <termios.h>
#include <unistd.h>  // usleep 
#include <fcntl.h>   // file serial stuff 
#include <sys/ioctl.h>
#include "usb_i2c.h"
#include "md23.h"

// This uses Mode 0 of the MD23 to set the wheels to spin till motor1 has
// recorded 1000 ticks.
// KMN 7/17/2007

void SetSpeed(BYTE addr, BYTE speed1, BYTE speed2) {
	BYTE *sbuf;
	unsigned int enc1=0, enc2=0;
	int i;
	unsigned int oldenc1,oldenc2;

#if 0
	// Verify the address by reading the rev
	printf("Checking address 0x%02X for MD23 ...",addr);
	sbuf = Read_i2c(addr,MD23_REVISION,1);
	if(sbuf[0]>0 && sbuf[0]<20) { // found one!
			printf("found one, revision %i!\n",sbuf[0]);
	}
	free(sbuf);

#endif
 	printf("Sending reset...");
	Write_i2c(addr,MD23_COMMAND,CLEAR_ENCS);

	// Verify the address by reading the rev
	printf("Set Mode to Unsigned...");  fflush(stdout);
	Write_i2c(addr,MODE,0);
 	printf("done.\n");  fflush(stdout);

	printf("Sending Speeds to MD23 @ %02x .. ",addr);
	Write_i2c(addr,SPEED1,speed1);
	Write_i2c(addr,SPEED2,speed2);

	i=0;
	while (enc1<1000) {
			  sbuf = Read_i2c(addr,ENC1A,8);
			  if (sbuf == NULL) return;
			  enc1 = (sbuf[0]<< 3*8) +
						(sbuf[1]<< 2*8) +
						(sbuf[2]<< 1*8) +
						sbuf[3];
			  enc2 = (sbuf[4]<< 3*8) +
						(sbuf[5]<< 2*8) +
						(sbuf[6]<< 1*8) +
						sbuf[7];
			  printf("%03i : enc1 = %i\t enc2=%i\t denc1=%i\tdenc2=%i\n",i,enc1,enc2,enc1-oldenc1,enc2-oldenc2);
			  free(sbuf);
			  usleep(1000);
			  oldenc1 = enc1;
			  oldenc2 = enc2;
			  i++;
	}

	Write_i2c(addr,SPEED1,128);
	Write_i2c(addr,SPEED2,128);

	for (i=0;i<100;i++) {
			  sbuf = Read_i2c(addr,ENC1A,8);
			  if (sbuf == NULL) return;
			  enc1 = (sbuf[0]<< 3*8) +
						(sbuf[1]<< 2*8) +
						(sbuf[2]<< 1*8) +
						sbuf[3];
			  enc2 = (sbuf[4]<< 3*8) +
						(sbuf[5]<< 2*8) +
						(sbuf[6]<< 1*8) +
						sbuf[7];
			  printf("%03i : enc1 = %i\t enc2=%i\t denc1=%i\tdenc2=%i\n",i,enc1,enc2,enc1-oldenc1,enc2-oldenc2);
			  free(sbuf);
			  usleep(1000*1000);
			  oldenc1 = enc1;
			  oldenc2 = enc2;
	}
}


int main (int argc, char *argv[]) {
 BYTE addr=0xb4;

 if (SerialOpen("/dev/ttyUSB0",B19200)<0)
	if (SerialOpen("/dev/ttyUSB1",B19200)<0) {
			fprintf(stderr,"Problem opening port");
			return -1;
 }

 SetSpeed(addr,128+20,128);
 return 0;
} 
